/*
 * Solution to Master Mind Hints
 */
#include <stdio.h>

#define MAXN 1000

int code[MAXN];			/* the current secret code */
char match[MAXN];		/* match type (w/respect to code) */
int guess[MAXN];		/* the current guess */
int hint[2];			/* the hint */
int n;				/* length of the code */

void generate_hint()
{
    int i, j;

    /* First identify all strong matches */
    for(i=0;i<n;i++)
	if (guess[i] == code[i]) match[i] = 'S';	/* strong match */
	else match[i] = ' ';		/* no match yet */

    /* Now identify the remaining weak matches */
    for(i=0;i<n;i++) {
	if (match[i] == 'S') continue;		/* already a strong match */
	for (j=0;j<n;j++) {
	    if (match[j] != ' ') continue;	/* element matched already */
	    if (guess[i] != code[j]) continue;	/* no match */
	    match[j] = 'W';			/* weak match */
	    break;
	}
    }

    /* Now count the strong and weak matches */
    hint[0] = hint[1] = 0;
    for (i=0;i<n;i++) switch(match[i]) {
	case 'S': hint[0]++; break;
	case 'W': hint[1]++; break;
    }
}

main()
{
    int i, gameno = 0;

    for(;;) {
	scanf("%d",&n);		/* get parameter for this game */
	if (n == 0) exit(0);		/* all done! */
	printf("Game %d:\n", ++gameno);
	for(i=0;i<n;i++) scanf("%d",code+i);	/* get the secret code */
	for(;;) {
	    for(i=0;i<n;i++) scanf("%d",guess+i);	/* get a guess */
	    if (guess[0] == 0) break;			/* end of game */
	    generate_hint();
	    printf("    (%d,%d)\n", hint[0], hint[1]);
	}
	putchar('\n');
    }
}
