/* Non-stop Travel Solution */

#include <stdio.h>

#define MAXNODES 10

int nnodes;					/* # of intersections */
int map[MAXNODES][MAXNODES];			/* map of the area */
	/* map[i][j] = -1 => no direct path from i and j */
	/*           = 0 => no signal at j when approached from i */
	/*           > 0 => average delay at j when approached from i */
int path[MAXNODES];	/* nodes in the path */
int plen;		/* path length (# of nodes) */

struct {
    int prev, len, perm;
} state[MAXNODES];

find_path (int start, int stop)
{
    int i, k, tlen, first, min;

    for (i=0;i<nnodes;i++) {
	state[i].prev = -1;
	state[i].len = -1;
	state[i].perm = 0;
    }
    state[stop].len = 0;
    state[stop].perm = 1;
    k = stop;
    for(;;) {
	for(i=0;i<nnodes;i++)
	    if (map[i][k] != -1 && !state[i].perm)
		if (state[i].len == -1 ||
		    state[k].len + map[i][k] < state[i].len)  {
			state[i].prev = k;
			state[i].len = state[k].len + map[i][k];
		}
	first = 1;
	for(i=0;i<nnodes;i++)
	    if (!state[i].perm)
		if (state[i].len != -1 && (first || state[i].len < min)) {
		    min = state[i].len;
		    k = i;
		    first = 0;
		}
	state[k].perm = 1;
	if (k == start) break;
    }
    k = start;
    i = 0;
    do {
	path[i++] = k;
	k = state[k].prev;
    } while (k != -1);
    plen = i;
}

main()
{
    int caseno = 0;					/* which case */
    int i, j, nout, to_node, sig_delay;
    int start_node, stop_node;
    int delay;

    for(;;) {
	scanf("%d",&nnodes);
	if (nnodes == 0) exit(0);			/* normal end */
	caseno++;
	for(i=0;i<nnodes;i++)
	    for(j=0;j<nnodes;j++) map[i][j] = -1;
	for(i=0;i<nnodes;i++) {
	    scanf("%d",&nout);		/* outdegree at node i */
	    for (j=0;j<nout;j++) {
		scanf("%d%d",&to_node,&sig_delay);
		map[i][to_node-1] = sig_delay;	/* to_node is 1-origin */
	    }
	}
	scanf("%d%d",&start_node,&stop_node);
	find_path(start_node-1,stop_node-1);
	printf("Case %d: ", caseno);
	printf("Path =");
	for(i=0;i<plen;i++) printf(" %d",path[i]+1);
	delay = 0;
	for(i=0;i<plen-1;i++) delay += map[path[i]][path[i+1]];
	printf("; %d second delay\n", delay);
    }
}
